# A description of what this class does
#
# @summary installs letsencrypt package and renew cronjob
#
# @example
#   include letsencrypt

class letsencrypt {

case $::osfamily {

/RedHat/: {
  notify{'RedHat Family found': }
  case $::operatingsystemmajrelease {
  /7|8|9/: {
    notify{'Version 7-9 found': }
    package { 'certbot': ensure => 'latest', allow_virtual => false }
    cron { 'renewcerts':
      ensure  => 'present',
      command => '/bin/systemctl stop httpd && letsencrypt renew && /bin/systemctl start httpd',
      weekday => ['7'],
      hour    => ['4'],
      minute  => ['0'],
      target  => 'root',
      user    => 'root',
      }
  }
  /4|5|6/: {
    notify{'Version 4-6 found': }
    package { 'git': ensure => 'latest', allow_virtual => false }

    vcsrepo { '/opt/certbot':
      ensure            => latest,
      provider          => git,
      trust_server_cert => true,
      source            => 'https://github.com/certbot/certbot',
      }

    cron { 'renewcerts':
      ensure  => 'present',
      command => '/sbin/service httpd stop && /opt/certbot-auto renew && /sbin/service httpd start',
      weekday => ['7'],
      hour    => ['4'],
      minute  => ['0'],
      target  => 'root',
      user    => 'root',
      }
  }
  default: {
    fail('No supported version')
    }
  }
}
/Debian|Ubuntu/: {
  notify{'Debian family found': }
  case $::operatingsystemmajrelease {
  /8|9|16.04|17.10|18.04/: {
      package { 'certbot': ensure => 'latest', allow_virtual => false }
      cron { 'renewcerts':
        ensure  => 'present',
        command => '/usr/sbin/service apache2 stop && certbot-auto renew && /usr/sbin/service apache2 start',
        weekday => ['7'],
        hour    => ['4'],
        minute  => ['0'],
        target  => 'root',
        user    => 'root',
        }
    }

default: {
  fail('No supported version')
  }
  }
}
default: {
  fail('No supported osfamily')
  }
}


}
